/***************************************************************************
 $RCSfile$
                             -------------------
    cvs         : $Id: kbanking.h 406 2007-04-30 18:13:29Z martin $
    begin       : Mon Mar 01 2004
    copyright   : (C) 2004 by Martin Preuss
    email       : martin@libchipcard.de

 ***************************************************************************
 *          Please see toplevel file COPYING for license details           *
 ***************************************************************************/

#ifndef QBANKING_QBGUI_H
#define QBANKING_QBGUI_H


#include <qbanking/qbanking.h>
#include <qbanking/qgui.h>

#include <gwenhywfar/gui.h>



class QBANKING_API QBGui: public QGui {
private:
  GWEN_DB_NODE *dbPasswords;
  GWEN_DB_NODE *dbCerts;
  std::list<std::string> _badPasswords;

  std::string _getPasswordHash(const char *token, const char *pin);
  int _checkCert(const GWEN_SSLCERTDESCR *cd,
		 GWEN_IO_LAYER *io,
		 uint32_t guiid);

  std::string _xl(const char *t);

public:
  QBGui(QBanking *qb);
  virtual ~QBGui();

  int getPassword(uint32_t flags,
		  const char *token,
		  const char *title,
		  const char *text,
		  char *buffer,
		  int minLen,
		  int maxLen,
		  uint32_t guiid);

  int setPasswordStatus(const char *token,
			const char *pin,
			GWEN_GUI_PASSWORD_STATUS status,
			uint32_t guiid);

  int checkCert(const GWEN_SSLCERTDESCR *cert,
		GWEN_IO_LAYER *io,
		uint32_t guiid);

};



#endif

